"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

var _react = _interopRequireWildcard(require("react"));

var _styles = require("@material-ui/core/styles");

var _core = require("@material-ui/core");

var _icons = require("@material-ui/icons");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const useStyles = (0, _styles.makeStyles)(theme => ({
  root: {
    padding: "2px 4px",
    borderColor: theme.palette.primary.main,
    borderWidth: "1px",
    borderStyle: "solid",
    borderRadius: "6px",
    alignItems: "center",
    backgroundColor: "#fff",
    '&:hover': {
      backgroundColor: '#eee'
    }
  },
  legend: {
    marginLeft: theme.spacing(2),
    paddingLeft: theme.spacing(2),
    backgroundColor: "#fff"
  },
  input: {
    margin: theme.spacing(1),
    paddingRight: theme.spacing(1),
    flex: 1
  },
  '@global': {
    '.MuiInputBase-root.Mui-disabled': {
      color: '#000000'
    },
    'textarea:disabled': {
      color: '#000000'
    }
  },
  iconButton: {
    padding: 10
  },
  divider: {
    height: 2,
    margin: 4
  },
  helpText: {
    color: '#6b6b6b'
  },
  error: {
    marginLeft: theme.spacing(1),
    color: "indianred"
  }
}));
const NoError = {
  isWrong: false,
  message: ""
};

const IPMDComment = _ref => {
  let {
    value,
    setValue,
    primaryLabel,
    secondaryLabel,
    errorMessage,
    readOnly,
    lines,
    sendFunc,
    maxLength,
    helpText
  } = _ref;
  const [error, setError] = (0, _react.useState)(NoError);
  const classes = useStyles();
  const label1 = secondaryLabel ? /*#__PURE__*/_react.default.createElement(_core.InputLabel, {
    shrink: true
  }, /*#__PURE__*/_react.default.createElement("div", null, primaryLabel), /*#__PURE__*/_react.default.createElement("div", null, secondaryLabel)) : primaryLabel;

  const checkValue = e => {
    const val = e.target.value;

    if (errorMessage && maxLength && val.length > maxLength) {
      setError({
        isWrong: true,
        message: errorMessage
      });
    } else setError(NoError);

    setValue(val);
  };

  return /*#__PURE__*/_react.default.createElement("fieldset", {
    className: classes.root
  }, /*#__PURE__*/_react.default.createElement("legend", {
    align: "left",
    className: classes.legend
  }, label1), /*#__PURE__*/_react.default.createElement(_core.InputBase, {
    value: value || "",
    multiline: true,
    rows: lines,
    onChange: checkValue,
    fullWidth: true,
    disabled: readOnly || false,
    error: error && error.isWrong,
    className: classes.input
  }), /*#__PURE__*/_react.default.createElement(_core.Divider, {
    className: classes.divider
  }), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    container: true,
    spacing: 2,
    justifyContent: "space-between",
    alignItems: "center"
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, error && error.isWrong && /*#__PURE__*/_react.default.createElement("label", {
    className: classes.error
  }, error.message)), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, !readOnly ? /*#__PURE__*/_react.default.createElement("span", null, value && value.length || "0", maxLength && "/".concat(maxLength)) : /*#__PURE__*/_react.default.createElement("span", {
    className: classes.helpText
  }, helpText && helpText), !readOnly && /*#__PURE__*/_react.default.createElement(_core.IconButton, {
    color: "primary",
    className: classes.iconButton,
    onClick: sendFunc,
    disabled: readOnly || error && error.isWrong
  }, error && error.isWrong ? /*#__PURE__*/_react.default.createElement(_icons.CancelScheduleSend, null) : /*#__PURE__*/_react.default.createElement(_icons.Send, null)))));
};

var _default = IPMDComment;
exports.default = _default;