"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.search.js");

var _core = require("@material-ui/core");

var _react = _interopRequireDefault(require("react"));

var _ipmdPager = _interopRequireDefault(require("./ipmdPager"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const IPMDGrid = _ref => {
  let {
    header,
    row,
    searchParams,
    searchFuncs,
    rows,
    totalRecordsCount,
    otherRowParams = {}
  } = _ref;

  const setPageSize = pageSize => {
    searchParams.pageSize = pageSize;
    searchFuncs.search(searchParams);
  };

  const setPage = page => {
    searchParams.page = page;
    searchFuncs.search(searchParams);
  };

  const totalPages = parseInt(totalRecordsCount / searchParams.pageSize) + (totalRecordsCount % searchParams.pageSize > 0 ? 1 : 0);
  return /*#__PURE__*/_react.default.createElement(_core.Grid, {
    container: true,
    spacing: 3
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: 3
  }, /*#__PURE__*/_react.default.createElement(_core.FormControl, {
    fullWidth: true
  }, /*#__PURE__*/_react.default.createElement(_core.InputLabel, null, "\u041F\u043E\u043A\u0430\u0436\u0438"), /*#__PURE__*/_react.default.createElement(_core.Select, {
    value: searchParams.pageSize,
    onChange: e => setPageSize(e.target.value)
  }, /*#__PURE__*/_react.default.createElement(_core.MenuItem, {
    value: 10
  }, "10"), /*#__PURE__*/_react.default.createElement(_core.MenuItem, {
    value: 20
  }, "20"), /*#__PURE__*/_react.default.createElement(_core.MenuItem, {
    value: 25
  }, "25"), /*#__PURE__*/_react.default.createElement(_core.MenuItem, {
    value: 50
  }, "50"), /*#__PURE__*/_react.default.createElement(_core.MenuItem, {
    value: 100
  }, "100")))), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: 4
  }, rows && /*#__PURE__*/_react.default.createElement("span", null, "\u041E\u0442\u043A\u0440\u0438\u0442\u0438 \u0441\u0430 ", totalRecordsCount, " \u0435\u043B\u0435\u043C\u0435\u043D\u0442\u0430")), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: 12
  }, header ? header(searchParams, searchFuncs) : null), rows.map((item, index) => /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: 12,
    key: index
  }, row(_objectSpread({
    searchParams,
    searchFuncs,
    item
  }, otherRowParams)))), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: 12
  }, /*#__PURE__*/_react.default.createElement(_ipmdPager.default, {
    totalPages: totalPages,
    page: searchParams.page,
    setPage: setPage
  })));
};

var _default = IPMDGrid;
exports.default = _default;