"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.search.js");

require("core-js/modules/es.string.match-all.js");

require("core-js/modules/es.promise.js");

var _react = _interopRequireWildcard(require("react"));

var _reactLeaflet = require("react-leaflet");

var _leafletGeosearch = require("leaflet-geosearch");

var _ipmdTB = _interopRequireDefault(require("./ipmdTB"));

var _core = require("@material-ui/core");

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// import 'leaflet/dist/leaflet.css'; // for react-leaflet to be rendered (used alternative in index.html)
const IPMDMap = _ref => {
  let {
    lat,
    // initial lat
    long,
    // initial long
    addressText,
    // starting address text if a pin with that address should be shown at the
    windowHeight,
    // define the height of the map window, default to 400px
    windowWidth,
    // define the widthe of the map window, default to 600px
    noDrag,
    // not allowed drag
    mouseDrag,
    // allowed drag for pin created on mouse click, even if noDrag is set
    showCurrentLocation,
    // puts a pin on the current location
    json,
    // draw markers, polygons, circles based on external geoJSON file
    jsonDetailed,
    // more detailed geoJSON file to be rendered above the zoomThreshold
    jsonFunc,
    // function evoked on zoomEnd, returns currentZoom and props with target Class and sourceTarget Class
    propertyToShow = {
      name: "name",
      center: "center",
      lat: " lat",
      lon: "lon"
    },
    // object with keys of the feature properties to be shown, serves for adaptation
    specificData,
    // specific data coming from outside { nuts4: "", nuts3: "", data: "data"}
    pin,
    // draw pins based on external list, each pin consisting in ['pin description', longitute, latitude, allowed drag on mouseDrag(optional)]
    admin,
    // allowed search options for setting location - install pins on locations
    nonAdminAddress,
    // за въвеждане на адрес от потребител без администраторски права
    disabled,
    // disable the search address button
    setPin,
    // allowed saving in external pin
    addressRecognition,
    // finds the closest real address based on coordinates when/after dragging
    colors,
    zoomThreshold,
    // zoom threshold above which the data is switched between json and jsonDetailed
    lang
  } = _ref;
  const initPos = [lat || 42.698334, long || 23.319941];
  const palette = colors ? _objectSpread({
    nuts4Color: 'grey',
    nuts3Color: 'green',
    selected: 'red'
  }, colors) : {
    nuts4Color: 'grey',
    nuts3Color: 'green',
    selected: 'red'
  };

  const LocationMarker = () => {
    const [position, setPosition] = (0, _react.useState)(null); // on click show your current position

    const map = (0, _reactLeaflet.useMap)();
    (0, _react.useEffect)(() => {
      if (map) {
        map.locate();
      }
    }, [map]);
    (0, _reactLeaflet.useMapEvents)({
      overlayadd(e) {
        if (e.name === "show me where I am") {
          map.flyTo(position, map.getZoom());
        }
      },

      locationfound(e) {
        setPosition(e.latlng);
      }

    });
    return position && /*#__PURE__*/_react.default.createElement(_reactLeaflet.Marker, {
      position: position
    }, /*#__PURE__*/_react.default.createElement(_reactLeaflet.Popup, null, "You are here"));
  };

  const ClickMarker = () => {
    (0, _reactLeaflet.useMapEvent)('click', e => {
      if (admin) {
        const numbers = e.latlng;
        const pinnedNew = [/*#__PURE__*/_react.default.createElement("p", null, "lat: ", numbers.lat, ",", /*#__PURE__*/_react.default.createElement("br", null), " lng: ", numbers.lng), numbers.lng, numbers.lat, Boolean(mouseDrag)]; // console.log('pinnedNew', pinnedNew);

        setPinned([...pinned, pinnedNew]);
      }
    });
    return null; // latlng && <DraggableMarker dragPos={latlng} />
  }; // const DraggableMarker = ({dragPos}) => { // transform a marker to draggableMarker
  //     const [draggable, setDraggable] = useState(false);
  //     const [dragPosition, setDragPosition] = useState({
  //         lat: dragPos.lat,
  //         lng: dragPos.lng,
  //     });
  //     const markerRef = useRef(null);
  //     const eventHandlers = useMemo(() => ({
  //         dragend() {
  //           const marker = markerRef.current
  //           if (marker != null) {
  //             setDragPosition(marker.getLatLng());
  //           }
  //         },
  //     }),[],);
  //     const toggleDraggable = useCallback(() => {
  //         setDraggable((d) => !d);
  //     }, []);
  //     return (
  //       <Marker
  //         draggable={mouseDrag? draggable : false}
  //         eventHandlers={eventHandlers}
  //         position={dragPosition}
  //         ref={markerRef}>
  //         <Popup minWidth={90}>
  //             {mouseDrag && <span onClick={toggleDraggable}>
  //                 {draggable
  //                     ? 'Преместваем маркер'
  //                     : 'Кликнете върху маркера, за да стане преместваем'}
  //             </span>}
  //             {<p>lat: {dragPosition.lat},<br /> lng: {dragPosition.lng}</p>}
  //         </Popup>
  //       </Marker>
  //     );
  // };


  const maxMin = (type, lst) => {
    let maximumLat = -90;
    let minimumLat = 90;
    let maximumLng = -90;
    let minimumLng = 90; // case Polygon

    if (type === "Polygon") for (let el of lst) {
      let maxLat = -90;
      let maxLng = -90;
      let minLat = 90;
      let minLng = 90;

      for (let e of el) {
        if (e[0] > maxLng) maxLng = e[0];
        if (e[1] > maxLat) maxLat = e[1];
        if (e[0] < minLng) minLng = e[0];
        if (e[1] < minLat) minLat = e[1];
      }

      if (maxLng > maximumLng) maximumLng = maxLng;
      if (maxLat > maximumLat) maximumLat = maxLat;
      if (minLng < minimumLng) minimumLng = minLng;
      if (minLat < minimumLat) minimumLat = minLat;
    } // case MultiPolygon
    else if (type === "MultiPolygon") for (let el of lst) {
      let maxLat = -90;
      let maxLng = -90;
      let minLat = 90;
      let minLng = 90;

      for (let ele of el) {
        for (let e of ele) {
          if (e[0] > maxLng) maxLng = e[0];
          if (e[1] > maxLat) maxLat = e[1];
          if (e[0] < minLng) minLng = e[0];
          if (e[1] < minLat) minLat = e[1];
        }
      }

      if (maxLng > maximumLng) maximumLng = maxLng;
      if (maxLat > maximumLat) maximumLat = maxLat;
      if (minLng < minimumLng) minimumLng = minLng;
      if (minLat < minimumLat) minimumLat = minLat;
    } else if (type === "Point") {
      return lst;
    } // console.log('feature name: ', feature.properties.name, ', type: ', feature.geometry.type, 
    //             ',\n centerlat:', (maximumLat + minimumLat) / 2, ', centerlng', (maximumLng + minimumLng) / 2);

    return [(maximumLat + minimumLat) / 2, (maximumLng + minimumLng) / 2];
  };

  const GeoJSONadd = _ref2 => {
    let {
      specificData
    } = _ref2;
    const geoJsonLayer = (0, _react.useRef)(null);
    const map = (0, _reactLeaflet.useMap)();
    let jsonData = json;
    const mapEvents = (0, _reactLeaflet.useMapEvents)({
      zoomend: props => {
        const currentZoom = mapEvents.getZoom();

        if (jsonDetailed && currentZoom > (zoomThreshold || 8)) {
          jsonData = jsonDetailed;
          geoJsonLayer.current && geoJsonLayer.current.clearLayers().addData(jsonDetailed);
        } else {
          jsonData = json;
          geoJsonLayer.current && geoJsonLayer.current.clearLayers().addData(json);
        }

        if (jsonFunc) jsonFunc(currentZoom, props);
      }
    });
    let style = (0, _react.useCallback)(feature => {
      if (feature.properties) {
        if (specificData) {
          // if specific data coming from outside { nuts4: "", nuts3: "", data: "data"}
          // ако има nuts3 и в specificData и в JSON.properties слага data на всеки nuts3
          if (specificData[0] && specificData[0].nuts4 && specificData.find(x => x.nuts4 === feature.properties.nuts4)) {
            return {
              color: palette.nuts4Color
            }; // ако не слага търси да сложи nuts4 ако ги има и в двата
          } else if (specificData[0] && specificData[0].nuts3 && specificData.find(x => x.nuts3 === feature.properties.nuts3)) {
            return {
              color: palette.nuts3Color
            }; // иначе слага само JSON(type = "Feature").properties.name
          } else {
            return;
          }
        } else {
          return;
        }
      }
    }, [specificData]);
    const onEachFeature = (0, _react.useCallback)((feature, layer) => {
      let centerLat, centerLng;
      if (feature.geometry.coordinates) [centerLat, centerLng] = maxMin(feature.geometry.type, feature.geometry.coordinates);

      if (feature.properties) {
        if (specificData) {
          // if specific data coming from outside { nuts4: "", nuts3: "", data: "data"}
          // ако има nuts3 и в specificData и в JSON.properties слага data на всеки nuts3
          if (specificData[0] && specificData[0].nuts4 && specificData.find(x => x.nuts4 === feature.properties.nuts4)) {
            const element = specificData.find(x => x.nuts4 === feature.properties.nuts4);
            layer.bindPopup("<div style=\"overflow-x: auto;\">".concat(lang && lang === "bg" ? element.data : element.dataen, "</div>")); // ако не слага търси да сложи nuts4 ако ги има и в двата
          } else if (specificData[0] && specificData[0].nuts3 && specificData.find(x => x.nuts3 === feature.properties.nuts3)) {
            const element = specificData.find(x => x.nuts3 === feature.properties.nuts3);
            layer.bindPopup("<div style=\"overflow-x: auto;\">".concat(lang && lang === "bg" ? element.data : element.dataen, "</div>")); // иначе слага само JSON(type = "Feature").properties.name
          } else {
            layer.bindPopup(feature.properties.name);
          }
        } else {
          layer.bindPopup(feature.properties[propertyToShow.name] + "".concat(propertyToShow.center ? "<br/> ".concat(propertyToShow.center, ": [").concat(propertyToShow.lat, ": ").concat(centerLat, ", ").concat(propertyToShow.lon, ": ").concat(centerLng, "]") : ''));
        }
      }

      layer.on({
        dblclick: props => {
          setTimeout(() => {
            // fitting to bounds
            map.fitBounds(props.sourceTarget._bounds);
            layer.setStyle({
              fillColor: palette.selected
            });
          }, 500);
          if (jsonFunc) jsonFunc(props);
        },
        popupopen: props => {
          layer.setStyle({
            fillColor: palette.selected
          });
        },
        popupclose: props => {
          if (geoJsonLayer.current) {
            geoJsonLayer.current.resetStyle(props.target);
          }
        }
      });

      if (propertyToShow) {
        layer.on({
          mouseover: props => {
            layer.bindTooltip("".concat(props.sourceTarget.feature.properties[propertyToShow.TooltipName] ? props.sourceTarget.feature.properties[propertyToShow.TooltipName][lang] : props.sourceTarget.feature.properties[propertyToShow.name])).openTooltip();
          },
          mouseout: props => {
            layer.unbindTooltip();
          }
        });
      }
    }, [specificData, map]);
    (0, _react.useEffect)(() => {
      if (geoJsonLayer.current) {
        geoJsonLayer.current.clearLayers().addData(jsonData);

        if (pin && pin.length === 0) {
          map.fitBounds(geoJsonLayer.current.getBounds());
        }
      } // eslint-disable-next-line

    }, []);
    return /*#__PURE__*/_react.default.createElement(_reactLeaflet.GeoJSON, {
      ref: geoJsonLayer,
      data: jsonData,
      onEachFeature: onEachFeature,
      style: style
    });
  };

  const [searchValue, setSearchValue] = (0, _react.useState)('');
  const [pinned, setPinned] = (0, _react.useState)([]);
  const [searchRes, setSearchRes] = (0, _react.useState)(null);
  const [anchorEl, setAnchorEl] = (0, _react.useState)('');
  (0, _react.useEffect)(() => {
    setPinned(pin || []);
  }, [pin]);

  const getPosition = item => {
    if (!nonAdminAddress) {
      setPinned([...pinned, [item.label, item.x, item.y]]);
      if (setPin) setPin([...pinned, [item.label, item.x, item.y]]);
    } else {
      setPinned([[item.label, item.x, item.y]]);
      if (setPin) setPin([[item.label, item.x, item.y]]);
    }

    setSearchRes(null);
    setAnchorEl('');
    setSearchValue('');
  };

  const [searchError, setSearchError] = (0, _react.useState)({
    isWrong: false,
    error: ''
  });

  const searchHandler = e => {
    if (switchState) {
      // setup OpenStreet MapProvider
      const provider = new _leafletGeosearch.OpenStreetMapProvider();
      setAnchorEl(e.currentTarget);
      provider.search({
        query: searchValue
      }).then(results => {
        // console.log('res', results);
        if (results) {
          setSearchRes(results.map((x, idx) => {
            return /*#__PURE__*/_react.default.createElement(_core.MenuItem, {
              button: true,
              key: idx,
              onClick: () => getPosition(x)
            }, x.label);
          }));
          setSearchError({
            isWrong: false,
            message: ""
          });
        }
      }).catch(err => {
        setSearchError({
          isWrong: true,
          message: "Не е намерен такъв адрес. Моля проверете отново въведеното!"
        });
        setAnchorEl('');
      });
    } else {
      // [42.666, 23.333], [42.67994433260664, 23.34479885238278], [42.6908232, 23.414841115125306]
      const numbers = [...searchValue.matchAll(/\d+(.\d+)?/g)].map(x => Number(x[0]));

      if (!numbers.length || numbers.length % 2 !== 0) {
        setSearchError({
          isWrong: true,
          message: 'Координатите не са във формат lat, lng или броя на изписаните числа е нечетен!'
        });
        return;
      } else setSearchError({
        isWrong: false,
        message: ''
      });

      const pinnedNew = [/*#__PURE__*/_react.default.createElement("p", null, "lat: ", numbers[0], ",", /*#__PURE__*/_react.default.createElement("br", null), " lng: ", numbers[1]), numbers[1], numbers[0]];
      setPinned([...pinned, pinnedNew]);
      if (setPin) setPin([...pinned, pinnedNew]);
    }
  };

  const average = (pinnedLst, flag) => {
    let maxLat = -90;
    let minLat = 90;
    let maxLng = -90;
    let minLng = 90;

    for (let ele of pinnedLst) {
      if (ele[1] > maxLng) maxLng = ele[1];
      if (ele[1] < minLng) minLng = ele[1];
      if (ele[2] > maxLat) maxLat = ele[2];
      if (ele[2] < minLat) minLat = ele[2];
    }

    if (flag) return [[maxLat + 0.02, maxLng + 0.02], [minLat - 0.02, minLng - 0.02]];
    return [(maxLat + minLat) / 2, (maxLng + minLng) / 2];
  };

  const ResultField = _ref3 => {
    let {
      pinned
    } = _ref3;
    const map = (0, _reactLeaflet.useMap)();

    if (pinned.length > 0) {
      // map.setView(average(pinned), 8);
      map.fitBounds(average(pinned, true));
    }

    const markerRef = (0, _react.useRef)([]);

    const eventHandlers = index => ({
      async dragend() {
        const marker = markerRef.current[index];

        if (marker != null) {
          const currPos = marker.getLatLng(); // console.log('current pos: ', currPos);

          /* ESRI REVERSE GEOCODE
          //   const geocodeService = L.esri.Geocoding.geocodeService();
          ELG.reverseGeocode() // tokenRequired: add  .token('OAuth2.0 token string from ArcGIS account')
              .token(token)
              .latlng([currPos.lat, currPos.lng])
              .run(function (error, result) {
                  if (error) {
                      alert(`Error: ${error.message} - OAuth2.0 token string from ArcGIS account`);
                      return;
                  }
                  console.log('[result, currPos.lat, currPos.lng]: ', [result.address.Match_addr, currPos.lat, currPos.lng]);
                  setPinned([result.address, currPos.lng, currPos.lat]);
                  if (setPin)
                      setPin([result.address, currPos.lng, currPos.lat]);
              });
          */

          if (precisionSwitchState) {
            // LEAFLET-GEOSEARCH REVERSE
            const provider = new _leafletGeosearch.OpenStreetMapProvider();
            const url = provider.endpoint({
              query: {
                lat: currPos.lat,
                lon: currPos.lng
              },
              type: 1
            });

            if (url) {
              // console.log('reverse results: ', url);
              const request = await fetch(url);
              const json = await request.json(); // console.log('json', json.display_name, json.lat, json.lon);

              pinned[index] = [json.display_name, json.lon, json.lat];
            } else {
              pinned[index][0] = /*#__PURE__*/_react.default.createElement("p", null, "lat: ", currPos.lat, ",", /*#__PURE__*/_react.default.createElement("br", null), " lng: ", currPos.lng);
              pinned[index][1] = currPos.lng;
              pinned[index][2] = currPos.lat;
            }
          } else {
            pinned[index][0] = /*#__PURE__*/_react.default.createElement("p", null, "lat: ", currPos.lat, ",", /*#__PURE__*/_react.default.createElement("br", null), " lng: ", currPos.lng);
            pinned[index][1] = currPos.lng;
            pinned[index][2] = currPos.lat;
          }

          setPinned([...pinned]);
        }
      },

      popupopen() {
        if (admin && document.getElementById("grid".concat(index))) document.getElementById("grid".concat(index)).style.color = "red";
      },

      popupclose() {
        if (admin && document.getElementById("grid".concat(index))) document.getElementById("grid".concat(index)).style.color = "black";
      }

    });

    return pinned.length > 0 && pinned.map((item, index) => {
      return /*#__PURE__*/_react.default.createElement(_reactLeaflet.Marker, {
        ref: _ref4 => markerRef.current[index] = _ref4,
        key: index,
        draggable: !noDrag || item[3] || false,
        eventHandlers: eventHandlers(index),
        position: [item[2], item[1]]
      }, /*#__PURE__*/_react.default.createElement(_reactLeaflet.Popup, null, item[0]));
    });
  };

  const deletePin = index => {
    pinned.splice(index, 1);
    document.getElementById("grid".concat(index)).style.color = "black";
    setPinned([...pinned]);
    if (setPin) setPin([...pinned]);
  }; // const menuRef = useRef(<div></div>);
  // console.log('menuRef.current', menuRef.current);


  const [mainSwitchState, setMainSwitchState] = _react.default.useState(nonAdminAddress ? true : false);

  const handleMainSwitchChange = event => {
    setMainSwitchState(event.target.checked);
  };

  const [switchState, setSwitchState] = _react.default.useState(nonAdminAddress ? true : false);

  const handleSwitchChange = event => {
    setSwitchState(event.target.checked);
  };

  const [precisionSwitchState, setPrecisionSwitchState] = _react.default.useState(false);

  const handlePrecisionSwitchChange = event => {
    setPrecisionSwitchState(event.target.checked);
  };

  return /*#__PURE__*/_react.default.createElement(_core.Grid, {
    container: true,
    spacing: 2
  }, (admin || nonAdminAddress) && /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    container: true,
    xs: 12,
    spacing: 2
  }, admin && /*#__PURE__*/_react.default.createElement(_core.Typography, {
    component: "div"
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    component: "label",
    container: true,
    alignItems: "center",
    justifyContent: "center",
    spacing: 1
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: 12
  }, "\u0412\u044A\u0432\u0435\u0436\u0434\u0430\u043D\u0435:"), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, "\u041E\u0442 \u043A\u0430\u0440\u0442\u0430\u0442\u0430"), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, /*#__PURE__*/_react.default.createElement(_core.Switch, {
    checked: mainSwitchState,
    onChange: handleMainSwitchChange
  })), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, "\u0421 \u0442\u044A\u0440\u0441\u0435\u043D\u0435 ", mainSwitchState && 'на:')), mainSwitchState && /*#__PURE__*/_react.default.createElement(_core.Grid, {
    component: "label",
    container: true,
    alignItems: "center",
    justifyContent: "center",
    spacing: 1
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, "\u041A\u043E\u043E\u0440\u0434\u0438\u043D\u0430\u0442\u0438"), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, /*#__PURE__*/_react.default.createElement(_core.Switch, {
    checked: switchState,
    onChange: handleSwitchChange
  })), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, "\u0410\u0434\u0440\u0435\u0441\u0438")), addressRecognition && !switchState && /*#__PURE__*/_react.default.createElement(_core.Grid, {
    component: "label",
    container: true,
    alignItems: "center",
    justifyContent: "center",
    spacing: 1
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, "\u041C\u0430\u043A\u0441\u0438\u043C\u0430\u043B\u043D\u0430 \u043F\u0440\u0435\u0446\u0438\u0437\u043D\u043E\u0441\u0442 - \u043F\u043E\u043A\u0430\u0437\u0432\u0430\u043D\u0435 \u043D\u0430 \u043A\u043E\u043E\u0440\u0434\u0438\u043D\u0430\u0442\u0438"), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, /*#__PURE__*/_react.default.createElement(_core.Switch, {
    checked: precisionSwitchState,
    onChange: handlePrecisionSwitchChange
  })), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true
  }, "\u041F\u0440\u0438\u0431\u043B\u0438\u0436\u0430\u0432\u0430\u043D\u0435 \u0434\u043E \u043D\u0430\u0439-\u0431\u043B\u0438\u0437\u043A\u0438\u044F \u0440\u0430\u0437\u043F\u043E\u0437\u043D\u0430\u0442 \u0430\u0434\u0440\u0435\u0441"))), mainSwitchState && !disabled && /*#__PURE__*/_react.default.createElement(_core.Grid, {
    container: true,
    spacing: 2
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    container: true
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: true
  }, /*#__PURE__*/_react.default.createElement(_ipmdTB.default, {
    value: searchValue,
    setValue: setSearchValue,
    error: searchError
  })), /*#__PURE__*/_react.default.createElement(_core.Button, {
    onClick: searchHandler
  }, switchState ? "Търси по адреси" : "Сложи пиновете")), /*#__PURE__*/_react.default.createElement("p", {
    align: "right",
    style: {
      marginLeft: '10px',
      marginTop: '-8px'
    }
  }, " ", switchState ? '*Адресите е препоръчително да са във формат "номер, улица, квартал, община, град, област, пощенски код, държава"' : '*Координатите трябва да са във формат lat, lng')), /*#__PURE__*/_react.default.createElement(_core.Menu // ref={menuRef}
  , {
    anchorEl: anchorEl,
    open: Boolean(anchorEl),
    onClose: () => setAnchorEl('')
  }, searchRes)), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    xs: 6
  }, /*#__PURE__*/_react.default.createElement(_reactLeaflet.MapContainer, {
    center: initPos,
    zoom: 12,
    scrollWheelZoom: false,
    style: {
      height: "".concat(windowHeight || 400, "px"),
      width: "".concat(windowWidth || 600, "px")
    }
  }, /*#__PURE__*/_react.default.createElement(_reactLeaflet.TileLayer, {
    attribution: "\xA9 <a href=\"http://osm.org/copyright\">OpenStreetMap</a> contributors",
    url: "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"
  }), /*#__PURE__*/_react.default.createElement(ResultField, {
    pinned: pinned
  }), !mainSwitchState && /*#__PURE__*/_react.default.createElement(ClickMarker, null), json && /*#__PURE__*/_react.default.createElement(GeoJSONadd, {
    specificData: specificData
  }), showCurrentLocation && /*#__PURE__*/_react.default.createElement(LocationMarker, null), addressText && /*#__PURE__*/_react.default.createElement(_reactLeaflet.Marker, {
    position: initPos
  }, /*#__PURE__*/_react.default.createElement(_reactLeaflet.Popup, null, addressText)))), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    container: true,
    xs: 5,
    alignItems: "flex-start"
  }, admin && pinned.length > 0 && pinned.map((pin, index) => {
    return /*#__PURE__*/_react.default.createElement(_core.Grid, {
      item: true,
      container: true,
      id: "grid".concat(index),
      key: index,
      alignItems: "center"
    }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
      item: true,
      xs: 1
    }, index + 1), /*#__PURE__*/_react.default.createElement(_core.Grid, {
      item: true,
      xs: 10
    }, pin[0]), /*#__PURE__*/_react.default.createElement(_core.Grid, {
      item: true,
      xs: 1
    }, /*#__PURE__*/_react.default.createElement(_core.IconButton, {
      onClick: () => deletePin(index)
    }, /*#__PURE__*/_react.default.createElement(_Delete.default, null))));
  })));
};

var _default = IPMDMap;
exports.default = _default;